/* SnagIt Extension Initialization */

// The global instance of the COM server object
var snagit = null;
var snagitevents = null;
var isCapturing = false;
var oldSmoothScroll = false;

// Add dummy load event to work around bug in Mozilla 1.x/Netscape
// See: http://groups.google.com/groups?hl=en&lr=&selm=b56t3u%24jig7%40ripley.netscape.com
addEventListener("load", function dummy(event) {}, false);

// Add the real load event handler to initialize the toolbar
addEventListener("load", toolbarLoadHandler, false);




/* Utility functions */


// Disable or Restore Smooth Scrolling setting

function disableSmoothScroll() 
{
  try 
  {
    var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
    oldSmoothScroll = prefService.getBoolPref("general.smoothScroll");
    prefService.setBoolPref("general.smoothScroll", false);  
  }
  catch (e) {
  }
}

function restoreSmoothScroll() 
{
  try 
  {
    var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);  
    prefService.setBoolPref("general.smoothScroll", oldSmoothScroll);
  }
  catch (e) {
  }
}

var stoppedFlash = null;

function stopAnimations()
{
  try 
  {
  // Stop GIF animations
  gBrowser.selectedBrowser.stop();

  // Stop Flash animations
  var embeds = gBrowser.selectedBrowser.contentDocument.embeds;  
  var i;
  stoppedFlash = new Array();
  for (i=0; i<embeds.length; i++) 
  {
    try {
      var flash = embeds[i].QueryInterface(Components.interfaces.FlashIScriptablePlugin);
      if (flash && flash.IsPlaying()) {
        flash.StopPlay();
        stoppedFlash.push(flash);
      }
    }
    catch(e) {
    }
  }
  }
  catch(e) {
  }
}


function restoreAnimations()
{
  if (!stoppedFlash) 
    return;

  // Restart Flash animations that were stopped
  while (stoppedFlash.length > 0)
  {
     var flash = stoppedFlash.pop();
     try
     {
       flash.Play();
     }
     catch(e) 
     {
     }
  }
}


/* Handles SnagIt events fired from XPCOM object */

function nsSnagItEventHandler() {
}

nsSnagItEventHandler.prototype = 
{
      OnStateChange: function (state) {         
         // If the capture was started and now it changed to idle, 
         // the capture itself is complete
         if (isCapturing && state == 0) { 
            // Restore original settings
            isCapturing = false;                    
            restoreAnimations();
            restoreSmoothScroll();
         }
      },  
      OnHelp : function (state) {
         if ( state == 0 )
         {
            window.open("http://www.techsmith.com/redirect.asp?product=snagit&lang=enu&target=powertoyfirefoxhelp");         
         }
         else if( state == 1 )
         {
            window.open("http://www.techsmith.com/redirect.asp?product=snagit&lang=deu&target=powertoyfirefoxhelp");          
         }
         else if( state == 2 )
         {
            window.open("http://www.techsmith.com/redirect.asp?product=snagit&lang=fra&target=powertoyfirefoxhelp");          
         }
      },
      QueryInterface: function (iid) {
          if (iid.equals(Components.interfaces.nsISnagItCaptureEvents) ||
              iid.equals(Components.interfaces.nsISupports))
              return this;
 
         throw Components.results.NS_ERROR_NO_INTERFACE;
       }
}


function displayFirstRestartMessage() {
  try
  {
      const IPS = Components.interfaces.nsIPromptService;
      var prompter = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(IPS);      
      var SBS = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService);
      var stringsBundle = SBS.createBundle("chrome://snagitextension/locale/snagitextension.properties");
      var snagittitle = stringsBundle.GetStringFromName("snagittitle");
      var snagit721message = stringsBundle.GetStringFromName("snagit721message");
      var snagitlang = stringsBundle.GetStringFromName("snagitlang");
      var retval = prompter.confirmEx(window, snagittitle, snagit721message,  
         (IPS.BUTTON_TITLE_YES * IPS.BUTTON_POS_0) + (IPS.BUTTON_TITLE_NO * IPS.BUTTON_POS_1), null, null, null, null, { });
      if (retval == 0) {
         window.open("http://www.techsmith.com/redirect.asp?target=snagitdownload&product=snagit&lang=" + snagitlang);
      }
  }
  catch (e) {
  }
}

// Setup menu lists with values stored in registry

function toolbarLoadHandler(event) 
{
      if ( document.getElementById("snagit_input_list") )
      {
         document.getElementById("snagit_input_list").selectedIndex = snagObj().inputType;
      }
      if ( document.getElementById("snagit_output_list") )
      {
         document.getElementById("snagit_output_list").selectedIndex = snagObj().outputType;
      }
      if ( document.getElementById("snagit_keeplinks_btn") )
      {
        try
        {       
            var bKeepLinks = getKeepLinks();
        }
        catch (e)
        {
            document.getElementById("snagit_keeplinks_btn").setAttribute("hidden", "true");
        }
        if ( bKeepLinks )
        {
          //document.getElementById("snagit_keeplinks_btn").setAttribute("checkState", 1);
          document.getElementById("snagit_keeplinks_btn").setAttribute("checked", "true" );
        }
        else
        {
          //document.getElementById("snagit_keeplinks_btn").setAttribute("checkState", 0 );
          document.getElementById("snagit_keeplinks_btn").removeAttribute("checked");
        } 
      }
      var snagit = snagObj();
      if ( snagit )
      {
        var snagit3 = snagit.QueryInterface(Components.interfaces.nsISnagIt3);
        if ( snagit3 )
        {
            var strSubInput;

            // hide if using snagit 9
            if ( !snagit3.supportsAllInOne )
            {
               strSubInput = document.getElementById("snagit_input_autoscroll").getAttribute("label");

               document.getElementById("snagit_input_allinone").setAttribute("hidden", "true" );
               if ( document.getElementById("snagit_input_list").selectedIndex == 0 )
               {
                  document.getElementById("snagit_input_list").selectedIndex = 1;
               }
            }
            else
            {
               strSubInput = document.getElementById("snagit_input_allinone").getAttribute("label");
            }
            var strTextInput = document.getElementById("snagit_input_text").getAttribute("label");
            document.getElementById("snagit_input_text").setAttribute("label", strTextInput + " [" + strSubInput + "]" );            
        }
      }     
}

// returns the global snagit object; creates it if necessary. Not creating the object until
// it is first needed allows us to keep snagit from running all the time if the user
// hasn't done any captures.

function snagObj()
{
   if ( ! snagit )
   {
      snagit = Components.classes["@techsmith.com/snagit;1"].createInstance(Components.interfaces.nsISnagIt);
      snagit.eventHandler = new nsSnagItEventHandler();
      if (snagit.firstRestart) {
        window.setTimeout("displayFirstRestartMessage()",100);
      }
   }
   return snagit;
}

// Starts a capture. Uses whatever is in the list, if it is showing.
// If not, the XPCOM object will use the last settings chosen in this
// window (from preferences).

function snagit_capture()
{

   if ( document.getElementById("snagit_input_list") )
   {
      snagObj().inputType = document.getElementById("snagit_input_list").selectedIndex;
   }
   
   if ( document.getElementById("snagit_output_list") )
   {
      snagObj().outputType = document.getElementById("snagit_output_list").selectedIndex;
   }
   
   stopAnimations();   
   disableSmoothScroll(); 
   isCapturing = true;
   if (!snagObj().capture())  // not a blocking call!
   { 
      // The capture did not even start.  Restore original settings.
      isCapturing = false;
      restoreSmoothScroll();
      restoreAnimations();
   }
}


// Tells the XPCOM object to launch the preferences dialog
// The preferences are stored in the object, but are read
// from the registry the first time it is started up. So, changing
// the properties of this object will affect this window and any new windows
// but not other currently open windows.

function snagit_options()
{
   if ( document.getElementById("snagit_input_list") )
   {
      snagObj().inputType = document.getElementById("snagit_input_list").selectedIndex;
   }
   
   if ( document.getElementById("snagit_output_list") )
   {
      snagObj().outputType = document.getElementById("snagit_output_list").selectedIndex;
   }
   
   snagObj().showPreferences();
   
   if ( document.getElementById("snagit_input_list") )
   {
      document.getElementById("snagit_input_list").selectedIndex = snagObj().inputType;
   }
   if ( document.getElementById("snagit_output_list") )
   {
      document.getElementById("snagit_output_list").selectedIndex = snagObj().outputType;
   }
}

function snagit_keeplinks()
{
  var bKeepLinks = true;
  if ( document.getElementById("snagit_keeplinks_btn").hasAttribute("checked") )
  {
    bKeepLinks = true; 
  }
  else
  {
    bKeepLinks = false;
  }
  setKeepLinks( bKeepLinks );
  return true;
}

function snagit_selectinput()
{
   snagObj().inputType = document.getElementById("snagit_input_list").selectedIndex;
}

function snagit_selectoutput()
{
   snagObj().outputType = document.getElementById("snagit_output_list").selectedIndex;
}

function setKeepLinks(bKeepLinks)
{
  var snagit = snagObj();
  if ( snagit )
  {
    var snagit2 = snagit.QueryInterface(Components.interfaces.nsISnagIt2);
    if ( snagit2 )
    {
        snagit2.keepLinks = bKeepLinks;
    }
  } 
}

function getKeepLinks()
{
  var snagit = snagObj();
  if ( snagit )
  {
    var snagit2 = snagit.QueryInterface(Components.interfaces.nsISnagIt2);
    if ( snagit2 )
    {
        return snagit2.keepLinks;
    }
  }
  return false;
}

